# 列表选择器

## 转树表格

描述一下常见被子植物与裸子植物

[list2table]
- 裸子植物
	- Cypress | 松树
		- 油松
		- 罗汉松
		- 马尾松
		- 红松
	- Ginkgo  | 柏树
	- Angiosperms | 银杏
- 被子植物
	- Sunflower | 向日葵
	- Lotus | 荷花
	- Chrysanthemum | 菊花

## （启用md语法）

描述一下各种常见编程语言的打印语句

[list2mdtable]
- **语言** | **打印语句** | **特点**
- java
	- 
		```java
		System.out.println("Hello World");
		```
		- 这语句有点长
- c
	- 
		```c
		printf("Hello World")
		```
        - 原始的C输出
- c++
    - 
        ```cpp
        std::cout<<"Hello Wrold"
        ```
        - 流输出，但是这东西开销大，竞赛党别用
- python
    - 
      ```python
        print("Hello World")
        ```
        - 需要注意一下Python2和Python3的打印语句不同
- js
    - 
      ```js
        console.log("Hello World");
        ```
        - 控制台打印

## 转列表格

@todo 这里样式可以再优化一下，甚至可能弄可折叠方案
描述一下公司结构：

[2lt]
- 名称 | 上级部门 | 负责人
- Obsidian开源集团
	- 上海分公司 | 开源集团  | 张三
		- 市场部 | 上海分公司 | 李四
		- 销售部 | 上海分公司 | 王五
	- 北京分公司 | 开源集团  | 陈六
		- 技术部 | 北京分公司 | 欧阳
		- 财务部 | 北京分公司 | 皇甫

## 列表转表格的另一种写法

描述一下你对下面各种水果的看法

[2ut]
- 水果
	- 颜色
	- 英文
- 苹果
	- 红色
	- apple
- 香蕉
	- 黄色
	- banana
- 橘子
	- 橙色
	- orange

或者（*该功能未完善，等待后续开发*）

[2ut]
- 苹果
	- 颜色: 红色
	- 英文: apple
- 香蕉
	- 颜色: 黄色
	- 英文: banana
- 橘子
	- 颜色: 橙色
	- 英文: orange

注意要项

[2mdut]
- 该模式下只能用二层列表
	- 多了无效1
		- 多了无效11
		- 多了无效12

## 列表转时间线

列表转时间线
@todo 这里样式可以再优化一下

[2mdut]
- 1840年6月
	- 英军发动鸦片战争
- 1842年8月
	- 清政府与英国签订《南京条约》:
	  1）中国割让香港岛给英国;
	  2）赔款洋银2100万元;
	  3）开放广州、厦门、福州、宁波、上海五处为通商口岸;
	  > [!note]+ 《南京条约》影响
	  > 1. 中国近代史上第一个不平等条约，给中国人民带来深重的灾难，开创了列强以条约形式侵略和奴役中国的恶例;
	  > 2. 中国的国家主权和领土完整遭到破坏，逐步沦为半殖民地半封建社会;
	  > 3. 中国社会的主要矛盾由地主阶级与农民阶级的矛盾，演变为帝国主义和中华民族的矛盾（主要矛盾)、封建主义和人民大众的矛盾;
	  > 4. 反侵略反封建成为中国人民肩负的两大历史任务;
	  > 5. 中国逐渐开始了反帝反封建的资产阶级民主革命。
	  >    
	   | | |
	   | ------ | -------------------------------------- |
	   | 1943年 | 中英《虎门条约》签订;                  |
	   | 1844年 | 中关《望厦条约》、中法《黄埔条约》签订 | 
- 1841年5月
	- 三元里人民的抗英斗争，是中国近代史上中国人民第一次大规模的反侵略武装斗争。
	  > ![ ](https://tse1-mm.cn.bing.net/th/id/R-C.4bbce1406f4442c1360edde26baa894d?rik=iHeUeby0jS5lnw&riu=http%3a%2f%2fp8.qhmsg.com%2fdr%2f270_500_%2ft01dbb76ff833d0a159.jpg&ehk=yggnC0t62%2b6DEVjvBgs%2fXJuuexBucd66FTc5gL0Gw%2fA%3d&risl=&pid=ImgRaw&r=0)
- 1851年1月
	- 洪秀全金田村发动起义，建号太平天国。1853年3月，占领南京,定为首都,改名天京，正式宜告太平天国农民政权的建立。颁布《天朝天亩制度》、天平军北伐



## 最后补充两个语法糖

- 语法糖1：当选择器为列表选择器，且[]第一个字符为2时，在前面追加list字符）
- 语法糖2：当[]第一个字符为!时，`[!XXX]`会自动变成`[code]\n ad-xxx`）

## 转流程图/脑图

描述一下树设计的脑图（由于ob的mermaid版本较低，没有mindmap，暂用流程图代替）

（@bug mermaid在这里有点bug，会闪一下。可能会考虑的解决方案：仅渲染模式生效）

[2mermaid]
- 树结构
	- 基本术语
	- 性质
	- 基本运算
	- 二叉树


