# 全局选择器

包括范围选择器、标题选择器等
- 局部选择器
	- 列表选择器
	- 引用块选择器
	- 代码块选择器
- 全局选择器
	- 首尾选择器
	- 标题选择器

全局选择器的特点：
- 可以包括很大一片区域，并且该区域可以有各种复合元素
- 为防止用户误操作，决定不提供 `总是识别` 功能

## 标题选择器

可以包括很大一片区域，且不需要选择结束位置
（@bug 注意：选择范围会包括标题自身，按理说不应该包括）

[quote]
### 标题d选择器示例

局部选择器
	- 列表选择器
	- 引用块选择器
	- 代码块选择器
- 全局选择器
	- 范围选择器
	- 标题选择器

能自动包括更小一级的标题

#### 引用块

> 12345

#### 代码块

~~~js
console.log("Hello World")
~~~

#### 公式块
$$
1+1=2
$$





## 首尾选择器

**（@bug 目前不能在渲染模式中生效）**

用`{[]`和`}.`将范围包起来即可，特点同样是包括很大一片区域，并且拥有极高的自由度，哪怕是破坏规则的方式
（该选择器甚至可以内联触发，但我将内联触发给关了）
首尾范围选择器很强大，但我并不推荐去滥用这种选择器，更推荐使用标题选择器替代之

例如：
{[quote]

### 局部选择器
- 局部选择器
	- 列表选择器
	- 引用块选择器
	- 代码块选择器

### 全局选择器
- 全局选择器
	- 范围选择器
	- 标题选择器

> 包括引用块
> 12345

包括代码块
```js
console.log("Hello World")
```

包括公式块
$$
1+1=2
$$
}.