## 插件分类

首先我们来分类一下渲染类的插件（我大体将OB插件分为管理类、辅助输入类、和渲染类）
渲染类中：现在大多数的特殊语法解析，有五种

1. 大都在**代码框**里做，比较著名的就是Ad的代码块语法
   （感觉Ad的代码框当“特殊引用块”的做法就有点难受了，甚至会觉得Callout是上位替代品）
2. callout是在**引用框**里做，其他的没见过
3. **整篇md文章**作为语法的解析，例如 Kanban
4. **前缀方式**，从前缀标识到空行为止的区域作为特殊语法格式的区域。优点是这是表格的超集，完全兼容传统表格的语法
5. **标签方式**（~~不过现有接口没有直接支持，如果要实现这种方式，就得自己重写一套md后处理器~~，好了，写出来了）


## 他们各自的优缺点

|方式|缺点|优点|插件举例|
|:---:|:----|:----|---|
|方式1|**不能进行Md语法解析**， <br> **解析语法失效会变得非常难看** ，<br>**不属于嵌套容器，虽然能强行嵌套**|可以使用代码解析来着色，适合代码内容。能避免md语法干扰|插件如：`dataview`, `mermaid`等 <br> 反例插件非常多，如：`Ad的代码框语法`、`聊天记录软件`(支持Md信息发送版)、里面嵌套有Md语法或图片的所有插件、`mindmap`(list生成脑图)|
|方式2|**每行">"符号和嵌套缩进非常麻烦**，特别是内容非常长时<br>（相较于代码块）|可以使用Md语法解析来着色|插件如：`Ad的Callout`语法| 
|方式3|整篇文章使用|有方法2所有的优点，此外还不需要加代码块和引用块|插件如：`kanban`，`mindmap`|
|方式4|因为需要空行作为结束符，一般不能作为嵌套容器，也意味着内容不能有空格|有方法2,3所有的优点。此外标识符只需要加在前面|插件如：`list-callout`， <br> `Table Extended`的`-tx-`前缀（不要也行但偶尔出错），<br>` checklist`的`#todo`前缀（这个是全库识别与单独渲染），<br>`AnyBlock`的局部和标题选择器|
|方式5<br>--------|如果用了嵌套语法由于没缩进会比较难找|其实就是方式4的分支。有方法2,3所有的优点。此外加标签只需要加在前后即可|插件如：HTML代码、`AnyBlock`的首尾选择器|


## 为什么大部分插件都通过代码块实现？

目前大部分的插件都能通过代码块渲染特殊格式

主要是obsidian提供了一个很方便的api接口：
```js
this.registerMarkdownCodeBlockProcessor("chat-qq", (source, el, _) => {
    new Chat_qq(source, el, _, this).render()
});

```
只要实现这么一处接口，就可以轻松在实时和渲染模式中实现局部文本在特殊格式下渲染

但正如前面所说的，这种方式是有弊端的。

AnyBlock有两种方式解决这个问题：
1. 通过[块转化](5.%20使用示例%20-%20基于理念的灵活操作.md)功能，将不在代码块内的文本假装成是在代码块内。
   你可以通过该方式处理几乎所有的使用代码块的插件
2. 插件开发人员可以使用AnyBlock提供的[新接口](9.%20高级功能.md)，注册新的处理器来处理

## callout杂谈

前面的优缺点可能不那么直观，现在看一下实例：
（请反复切换 源码、实时、渲染模式 查看这一节内容）

### Ad插件写法

在callout语法出来之前，写起来是这样的：

```ad-note
### 标题

### 标题2

### 标题3

- 一个普通的列表
  - 一个普通的列表
    - 一个普通的列表
  - - 一个普通的列表

```

### Callout写法

在callout语法出来之后，写起来是这样的：

> [!note]
> ### 标题
> ### 标题2
> ### 标题3
> - 一个普通的列表
>  - 一个普通的列表
>    - 一个普通的列表
>    - 一个普通的列表

### Any-Block写法

用Any-Block（本插件），写起来是这样的（写法非常自由）

写法一：首尾选择器写法

{[code]
ad-note
#### 标题

#### 标题2

#### 标题3

- 一个普通的列表
  - 一个普通的列表
    - 一个普通的列表
  - - 一个普通的列表
}.

写法二：块转化写法（如果ob不支持callout语法，可以这样写，但ob 0.14支持了，现在就没必要了，这里仅供演示）

[quote2code]
> ad-note
> ### 标题
> ### 标题2
> ### 标题3
> - 一个普通的列表
>  - 一个普通的列表
>    - 一个普通的列表
>    - 一个普通的列表

写法三：标题选择器写法：

[!note]
#### 标题

##### 标题2

##### 标题3

- 一个普通的列表
  - 一个普通的列表
    - 一个普通的列表
  - - 一个普通的列表

