# 插件接入二次开发（文档编写中）

因为AnyBlock做了一件Obsidian标准接口里没有提供的功能 ———— 真正地将 “特殊语法” 从块里释放了出来。
得益于OB接口允许插件之间的通信，其他开发者如果想要将使用一种类似的功能，可以接入AB插件进行快速开发。

为了方便接入二次开发，这里
如果你并非程序员，也可以看一下第一节（Tree-Level）的内容，会让你对插件的设计和使用更加熟悉。

## Tree-Level

注意：这里的level数越小，代表父层次越高，level表示的其实是 `indent-level` 。并且这里允许level为非正数或非整数

tree-level
[2table]
- list的level | `-` 前的空格数量
- 位于根部正文的level | 0 （哪怕缩进，但注意列表下的缩进会被视为列表项）
- 负级列表的level（实验功能） | `<` 的数量的负数（范围 \[-3,-1]）
- 标题的level | `#` 的数量减去十（范围 \[-9,-4]）
- 特殊规则 - QA层的level | 0.5


## 注册新的处理器

<< 这是一种类似于 `registerMarkdownPostProcessor()` 的方法，主要区别：

要处理的文本不会局限于代码块中，而是基于 `Range`。
`Range` 可以通过各种局部或全局选择器进行选择，它会告诉你你要处理的是哪一部分的文本内容，你也可以在设置中打开 `线装饰` 功能，来查看被选择的文本范围。
然后，你可以使用新的注册器对该区域进行处理。

此外，该新的注册器还允许你使用正则等方式去匹配识别符

### 树格式

知识前置：[Tree-Level](#Tree-Level)
AB插件会自动将局部的列表选择器或全局选择器里的大纲，转化为树形格式
（用列表格式存储，相较于抽象语法树AST更类似于md-it的Tokens，但语法会简单得多）

```js
{
    level:number,
    content: str
}[]
```

你可以直接使用这个树形格式快速开发

### 处理器冲突问题

同种范围管理器的处理器，由于存在注册的先后问题并不会冲突。
不同范围管理器，则可能进行冲突。

如果他们的范围是真包含关系，范围更大的有可能影响范围更小的，也可能不影响（例如大范围的使用md方式）。
如果他们的范围是交错关系，则可能会产生bug。
一般而言不会发生后者这种情况，除非使用自由度较高的首尾范围选择器，这也是为什么我会说要谨慎使用首尾范围选择器，最好能用标题选择器来代替之


